#include <Math.au3>
#include <String.au3>
#include <Array.au3>
#include <Word.au3>

$fil = FileOpenDialog ("   ", @ScriptDir, "  (*.txt)", 1+4)
If @error Then My_Err("   -  " & @CRLF & @CRLF & "   ?")

$S = StringSplit($fil, '|')
If $S[0] <> 3 Then My_Err("   ")

$aArray = FileReadToArray($S[2])
if @error Then My_Err("  " & $S[2])

$aArray2 = FileReadToArray($S[3])
if @error Then My_Err("  " & $S[3])

$fil =  StringReplace($S[2], ".txt", "_R.txt")

$N = UBound($aArray)-3
If $N <> UBound($aArray2)-3 Then My_Err("      !!" _
									& @CRLF & @CRLF & "     ==> " & UBound($aArray) _
									& @CRLF & @CRLF & "     ==> " & UBound($aArray2) )

If StringMid($aArray[1],42,2) = "R1" Then
   $aR = $aArray
   $aK = $aArray2
Else
   $aR = $aArray2
   $aK = $aArray
EndIf

$Nt = StringMid($aK[0],21,2) ;  

Local $Name[$N+1], $Num[$N+1] ; , -1

For $i = 1 To $N
   If StringMid($aR[2+$i],1,35) <> StringMid($aK[2+$i],1,35) Then My_Err("      !!" _
											 & @CRLF & @CRLF & "   ==> " & StringMid($aR[2+$i],1,35) _
											 & @CRLF & @CRLF & "   ==> " & StringMid($aK[2+$i],1,35) )
   $Name[$i] = StringStripWS(StringMid($aR[2+$i],12,26), 2) ;    
   $Num[StringMid($aR[2+$i],8,2)] = $i ;      
Next

FileWriteLine($fil, @CRLF & "   " & $N & " " &  @CRLF)
;  
FileWrite($fil, "" & @TAB & "" & @TAB)
For $j = 1 To $Nt
   FileWrite($fil, "R" & $j & @TAB)
Next
FileWrite($fil, "" & @TAB)
;My_Err(StringMid($aK[1],42,99))
$S = StringSplit(StringStripWS(StringMid($aK[1],43,99), 1+4), " ", 1) ;    
FileWrite($fil, $S[1] & @TAB & $S[2] & @TAB & $S[3] & @CRLF) ;  

For $i = 1 To $N ;  
   FileWrite($fil, $i & @TAB & $Name[$i] & @TAB)
   For $j = 1 To $Nt ;    -    ( )  
	  FileWrite($fil, $Num[StringMid($aR[2+$i],35+6*$j,2)] & StringMid($aR[2+$i],37+6*$j,2) & @TAB)
   Next
   FileWrite($fil, StringStripWS(StringMid($aK[2+$i],39,4), 8) & @TAB) ;    
   $S = StringSplit(StringStripWS(StringMid($aK[2+$i],43,99), 1+4), " ", 1) ;    
   FileWrite($fil, $S[1] & @TAB & $S[2] & @TAB & $S[3] & @CRLF) ;  
   ;_ArrayDisplay($S, ' ')
Next

;Exit


;  
$oWord = _Word_Create()       ;    Word
$oDoc =_Word_DocAdd($oWord)   ;     Word 
Const $WrdConst=2.835         ;   .    1      2.835

With $oDoc.PageSetup
   .PaperSize = 7                    ; wdPaperA4
   .Orientation = $WdOrientLandscape ;   -  :)
   .LeftMargin = 20*$WrdConst
   .RightMargin = 20*$WrdConst
   .TopMargin = 10*$WrdConst
   .BottomMargin = 1*$WrdConst
EndWith

$oRange = _Word_DocRangeSet($oDoc, -2)     ;     Word 
$oDoc.Tables.Add($oRange, 4+$N, 6+$Nt)     ;   
$oDoc.Tables(1).Style = " "    ;   
 ;      1 
With $oDoc.Tables.Item(1)
   .TopPadding = 0.1*$WrdConst;
   .BottomPadding = 0.1*$WrdConst;
   .RightPadding = 1*$WrdConst;
   .LeftPadding = 1*$WrdConst;
EndWith
;    
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,3+$N,1)
$oWord.Application.Selection.MoveDown($wdLine,5+$N,1)
With $oWord.Application.Selection
   .Font.Name='Times New Roman'
   .Font.Size = 12
   .ParagraphFormat.Alignment = 1 ;   
   .Cells.VerticalAlignment = 1 ; wdAlignVerticalCenter
   .ParagraphFormat.SpaceBefore = 0
   .ParagraphFormat.SpaceBeforeAuto = False
   .ParagraphFormat.SpaceAfter = 0
   .ParagraphFormat.SpaceAfterAuto = False
   .ParagraphFormat.LineUnitBefore = 0
   .ParagraphFormat.LineUnitAfter = 0
EndWith

;      
$oDoc.Tables.Item(1).Rows(1).Height=7*$WrdConst      ;  1-  7 
$oDoc.Tables.Item(1).Rows(2).Height=7*$WrdConst      ;  2-  7 
For $i = 3 To 2+$N
   $oDoc.Tables.Item(1).Rows(4+$N).Height=6*$WrdConst  ;    99 
Next
$oDoc.Tables.Item(1).Rows(4+$N).Height=10*$WrdConst  ;    10 

$oDoc.Tables.Item(1).Columns(1).Width=8*$WrdConst   ;  1-  8  - 
$oDoc.Tables.Item(1).Columns(2).Width=53*$WrdConst  ;  2-  53 

$oDoc.Tables.Item(1).Cell(1,3).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt-1,1) ;      
$oWord.Application.Selection.MoveDown($wdLine,3+$N,1)        ;
$oWord.Application.Selection.Cells.Width=11*$WrdConst        ;     99w0
;    
$oDoc.Tables(1).Cell(3,1).Range.Text = " "
$oDoc.Tables(1).Cell(3,2).Range.Text = ""
For $j = 1 To $Nt
 ;  $oDoc.Tables.Item(1).Cell(3+$j,2+$j).Select
 ;  $oWord.Application.Selection.Cells.Shading.Texture = 0x0000015E   ; 
   $oDoc.Tables(1).Cell(3,2+$j).Range.Text = "R"&$j                  ;  
   $oDoc.Tables(1).Cell(3,2+$j).Range.Font.Size = 11
Next
$oDoc.Tables(1).Cell(3,3+$Nt).Range.Text = ""
$S = StringSplit(StringStripWS(StringMid($aK[1],43,99), 1+4), " ", 1) ;    
$oDoc.Tables(1).Cell(3,4+$Nt).Range.Text = $S[1]   ;  
$oDoc.Tables(1).Cell(3,5+$Nt).Range.Text = $S[2]   ;  
$oDoc.Tables(1).Cell(3,6+$Nt).Range.Text = $S[3]   ;  

For $i = 1 To $N ;-$N
   $oDoc.Tables(1).Cell(3+$i,1).Range.Text = $i                      ;  
   $oDoc.Tables(1).Cell(3+$i,1).Range.Font.Bold = 1
   $oDoc.Tables(1).Cell(3+$i,2).Range.Text = $Name[$i]               ;  
   $oDoc.Tables(1).Cell(3+$i,2).Range.Font.Bold = 1
   For $j = 1 To $Nt ;    -    ( )  
	  $oDoc.Tables(1).Cell(3+$i,2+$j).Range.Text = $Num[StringMid($aR[2+$i],35+6*$j,2)] & StringMid($aR[2+$i],37+6*$j,2) ;  
	  $oDoc.Tables(1).Cell(3+$i,2+$j).Range.Font.Size = 10
   Next
   $oDoc.Tables(1).Cell(3+$i,3+$Nt).Range.Text = StringStripWS(StringMid($aK[2+$i],39,4), 8)   ;    
   $oDoc.Tables(1).Cell(3+$i,3+$Nt).Range.Font.Bold = 1
   $S = StringSplit(StringStripWS(StringMid($aK[2+$i],43,99), 1+4), " ", 1) ;    
   $oDoc.Tables(1).Cell(3+$i,4+$Nt).Range.Text = $S[1]   ;  
   $oDoc.Tables(1).Cell(3+$i,5+$Nt).Range.Text = $S[2]   ;  
   $oDoc.Tables(1).Cell(3+$i,6+$Nt).Range.Text = $S[3]   ;  
Next
;     -  .   
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt+5,1)
$oWord.Application.Selection.MoveDown($wdLine,1,1)
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 0
$oWord.Application.Selection.Cells.Borders.InsideLineStyle = 0
$oDoc.Tables.Item(1).Cell(4+$N,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt+5,1) ;    
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 0
$oWord.Application.Selection.Cells.Borders.InsideLineStyle = 0
;  
$oDoc.Tables.Item(1).Cell(3,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt+5,1) ;    
$oWord.Application.Selection.MoveDown($wdLine,$N,1)          ;
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  
$oDoc.Tables(1).Rows(3).Borders.OutsideLineStyle = 7
$oDoc.Tables.Item(1).Cell(3,3).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt-1,1) ;      
$oWord.Application.Selection.MoveDown($wdLine,$N,1)        ;
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  
$oDoc.Tables.Item(1).Cell(3,$Nt+3).Select
$oWord.Application.Selection.MoveDown($wdLine,$N,1)          ;
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  
;        -     
$oDoc.Tables.Item(1).Cell(1,1).Merge($oDoc.Tables.Item(1).Cell(1,6+$Nt))
$oDoc.Tables.Item(1).Cell(1,1).Split(1,3);
$oDoc.Tables(1).Cell(1,1).Range.Text = ": " & @MDAY & '.' & @MON & '.' & @YEAR
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 0 ;wdAlignParagraphLeft
$oDoc.Tables(1).Cell(1,3).Range.Text = ": " & @MDAY & '.' & @MON & '.' & @YEAR
$oDoc.Tables.Item(1).Cell(1,3).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 2 ;wdAlignParagraphRight
$oDoc.Tables(1).Cell(1,2).Range.Text = "                 "
$oDoc.Tables(1).Cell(2,1).Range.Text = "     !"
$oDoc.Tables(1).Cell(2,1).Range.Font.Bold = 1
$oDoc.Tables(1).Cell(2,1).Range.Font.Size = 16
$oDoc.Tables.Item(1).Cell(2,1).Merge($oDoc.Tables.Item(1).Cell(2,6+$Nt))
$oDoc.Tables.Item(1).Cell(4+$N,1).Merge($oDoc.Tables.Item(1).Cell(4+$N,6+$Nt))
$oDoc.Tables.Item(1).Cell(4+$N,1).Split(1,2);
$oDoc.Tables(1).Cell(4+$N,1).Range.Text = "  ____________________"
$oDoc.Tables.Item(1).Cell(4+$N,1).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 0 ;wdAlignParagraphLeft
$oDoc.Tables(1).Cell(4+$N,2).Range.Text = " ____________________"
$oDoc.Tables.Item(1).Cell(4+$N,2).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 2 ;wdAlignParagraphRight

ConsoleWrite ( " All good! " & UBound($aArray) & @CRLF)

Exit



Func My_Err($OutText) ;    -    
    MsgBox(0, '!!  ', $OutText)
	Exit
EndFunc
